- Object oriented programming allows grouping data and function together as classes. This allows easier reading and extension of the codebase.
- Inheritance helps eliminate code duplication (e.g. creating a hero class with shared attack function).
- Customization and code sharing can be achieved elegantly within an inheritance scheme (e.g. `__init__` of Wizard class).
- Abstract methods in parent classes are helpful to define the interface of the child classes by the parent (e.g. `special_move` in the).
- Abstract classes make sure that only the no instance can be created with an unimplemented/abstract method ( `Hero` class).
- Static variables allow data sharing between all instances of a class (e.g. `MAX_FREQUENCY_OF_SPECIAL_MOVE` variable of `Hero`class).
- A well-designed object oriented structure allows easy extension of the codebase (e.g. `Human`, `Dwarf`, and `Elf` classes).